package app.auto;

import org.jboss.cache.PropertyConfigurator;
import org.jboss.cache.TreeCache;
import org.springframework.context.ApplicationEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextClosedEvent;
import org.springframework.context.event.ContextRefreshedEvent;

import app.service.CacheServiceInterface;

public class LocalJBossCacheServiceImpl implements CacheServiceInterface,
ApplicationListener {

	private TreeCache cache;
	
	
	public LocalJBossCacheServiceImpl() throws Exception {
		super();
		cache = new TreeCache();
		PropertyConfigurator config = new PropertyConfigurator();
		config.configure(cache, "app/context/custom-cache-service.xml");
	}

	public void put(String path, Object key, Object value) throws Exception {
		cache.put(path, key, value);
	}

	public Object get(String path, Object key) throws Exception {
		return cache.get(path, key);
	}

	public void onApplicationEvent(ApplicationEvent event) {
	    try
	    {
	      if ( event instanceof ContextRefreshedEvent )
	      {
	        contextRefreshed( ( ContextRefreshedEvent ) event );
	      }

	      if ( event instanceof ContextClosedEvent )
	      {
	        contextClosed( ( ContextClosedEvent ) event );
	      }
	    }
	    catch ( Exception e )
	    {
	    	e.printStackTrace();
	    }		
	}

	private void contextClosed(ContextClosedEvent event) {
		cache.stopService();
	}

	private void contextRefreshed(ContextRefreshedEvent event) throws Exception {
		cache.startService();
	}



}
