package app.service;

import org.jboss.cache.TreeCacheListener;
import org.jboss.cache.TreeCacheMBean;
import org.springframework.beans.factory.InitializingBean;



public class JBossCacheServiceImpl implements CacheServiceInterface, InitializingBean {

	private TreeCacheMBean cacheMBean;
	private TreeCacheListener cacheListener = new DefaultCacheListener();
	
	public void put(String path, Object key, Object value) throws Exception {
		System.out.println("calling put:" + path + ": " + key + "=" + value);
		cacheMBean.put(path, key, value);
		//cacheMBean.getTransactionManager().commit();
	}

	public Object get(String path, Object key) throws Exception {
		System.out.println("calling get:" + path + ": " + key);
		return cacheMBean.get(path, key);
	}

	public void setCacheMBean(TreeCacheMBean cacheMBean) {
		this.cacheMBean = cacheMBean;
	}


	public void afterPropertiesSet() throws Exception {
		cacheMBean.addTreeCacheListener(cacheListener);
		System.out.println("aded listener");
	}


}
